package psi.rmi;

import java.rmi.*;

/**
 * Rozhrani RMI metod.
 */
public interface IRmiServer extends Remote {

	/**
	 * Vypocte determinant matice.
	 * @param m Matice pro vypocet determinantu.
	 * @return Determinant matice.
	 */
	int determinant(Matrix3 m) throws RemoteException;

	/**
	 * Vypocte soucet dvou matic.
	 * @param m1 Prvni matice.
	 * @param m2 Druha matice.
	 * @return Matice obsahujici soucet obou vstupnich matic.
	 */
	Matrix3 soucet(Matrix3 m1, Matrix3 m2) throws RemoteException;

	/**
	 * Vypocte soucin dvou matic.
	 * @param m1 Prvni matice.
	 * @param m2 Druha matice.
	 * @return Matice obsahujici soucin obou vstupnich matic.
	 */
	Matrix3 soucin(Matrix3 m1, Matrix3 m2) throws RemoteException;
}
