package psi.rmi;

import java.io.Serializable;

/**
 * Trida reprezentujici matici o rozmerech 3x3.
 */
public class Matrix3 implements Serializable {
	
	static final long serialVersionUID = 3734290325389286131L;

	int[][] matrix;

	public Matrix3(int[][] matrix) {
		if (matrix.length != 3 || matrix[0].length != 3) {
			throw new UnsupportedOperationException("Rozmery matice musi byt 3x3.");
		}

		this.matrix = matrix;
	}

	/**
	 * Vrati cislo nachazejici se na zadanych souradnicich v matici.
	 * @param m Cislo radku.
	 * @param n Cislo sloupce.
	 * @return Cislo nachazejici se na danem radku a sloupci.
	 */
	public int getNumber(int m, int n) {
		try {
			return matrix[m][n];
		} catch (ArrayIndexOutOfBoundsException e) {
			throw new ArrayIndexOutOfBoundsException("Index mimo rozsah 0 - 3");
		}
	}

	@Override
	public String toString() {
		String out = "";
		for (int i = 0; i < 3; i++) {
			for (int j = 0; j < 3; j++) {
				out += matrix[i][j];
				for (int k = 5 - String.valueOf(matrix[i][j]).length(); k > 0; k--) {
					out += " ";
				}
			}
			if (i < 2) {
				out += "\n";
			}
		}

		return out;
	}
}
