package psi.rmi;

import java.rmi.Naming;
import java.util.Random;

/**
 * Klientska aplikace.
 */
public class RmiClient {

	static String hostName = "localhost";

	public static void main(String args[]) {
		Random generator = new Random();

		// vytvoreni prvni matice
		int[][] pole = new int[3][3];
		for (int i = 0; i < 3; i++) {
			for (int j = 0; j < 3; j++) {
				pole[i][j] = generator.nextInt(10);
			}
		}
		Matrix3 m1 = new Matrix3(pole);

		// vytvoreni druhe matice
		pole = new int[3][3];
		for (int i = 0; i < 3; i++) {
			for (int j = 0; j < 3; j++) {
				pole[i][j] = generator.nextInt(10);
			}
		}
		Matrix3 m2 = new Matrix3(pole);

		int det1;
		int det2;
		Matrix3 soucet;
		Matrix3 soucin;

		// pripojeni se k serveru a vypocet hodnot
		try {
			IRmiServer server = (IRmiServer) Naming.lookup("//" + hostName + "/MyServer");

			det1 = server.determinant(m1);
			det2 = server.determinant(m2);

			soucet = server.soucet(m1, m2);
			soucin = server.soucin(m1, m2);

		} catch (Exception ex) {
			System.out.println("Nepodarilo se pripojit k RMI serveru: ");
			System.out.println(ex.getMessage());
			System.exit(1);
			return;
		}

		// vypis hodnot

		System.out.println("Matice A:");
		System.out.println(m1.toString());
		System.out.println("determinant: " + det1 + "\n");

		System.out.println("Matice B:");
		System.out.println(m2.toString());
		System.out.println("determinant: " + det2 + "\n");

		System.out.println("soucet matic (A + B):");
		System.out.println(soucet + "\n");

		System.out.println("Soucin matic (A x B):");
		System.out.println(soucin + "\n");

	}
}
