package psi.rmi;

import java.rmi.*;
import java.rmi.server.*;

/**
 * Serverova aplikace.
 */
public class RmiServer extends UnicastRemoteObject
		implements IRmiServer {

	static String HOST = "localhost";

	public RmiServer() throws RemoteException {
		super();
	}

	public static void main(String args[]) {
		try {
			RmiServer instance = new RmiServer();
			Naming.rebind("//" + HOST + "/MyServer", instance);
			System.out.println("Server je zaregistrovan.");
		} catch (Exception ex) {
			System.out.println(ex);
		}
	}

	public int determinant(Matrix3 m) {
		System.out.println("Vypocet determinantu.");
		return m.getNumber(0, 0) * m.getNumber(1, 1) * m.getNumber(2, 2)
				+ m.getNumber(1, 0) * m.getNumber(2, 1) * m.getNumber(0, 2)
				+ m.getNumber(2, 0) * m.getNumber(0, 1) * m.getNumber(1, 2)
				- m.getNumber(0, 0) * m.getNumber(2, 1) * m.getNumber(1, 2)
				- m.getNumber(1, 0) * m.getNumber(0, 1) * m.getNumber(2, 2)
				- m.getNumber(2, 0) * m.getNumber(1, 1) * m.getNumber(0, 2);
	}

	public Matrix3 soucet(Matrix3 m1, Matrix3 m2) {
		System.out.println("Vypocet souctu.");
		int[][] s = new int[3][3];

		for (int i = 0; i < 3; i++) {
			for (int j = 0; j < 3; j++) {
				s[i][j] = m1.getNumber(i, j) + m2.getNumber(i, j);
			}
		}

		return new Matrix3(s);
	}

	public Matrix3 soucin(Matrix3 m1, Matrix3 m2) {
		System.out.println("Vypocet soucinu.");
		int[][] s = new int[3][3];

		for (int i = 0; i < 3; i++) {
			for (int j = 0; j < 3; j++) {
				int tmp = 0;
				for (int k = 0; k < 3; k++) {
					tmp += m1.getNumber(i, k) * m2.getNumber(k, j);
				}
				s[i][j] = tmp;
			}
		}

		return new Matrix3(s);
	}
}
